﻿/*==============================================================================
 * Author:深度训练
 * Create time: 2013-08-04
 * Blog Address:http://www.cnblogs.com/wangiqngpei557/
 * Author Description:特定领域软件工程实践；
 *==============================================================================*/

namespace ConsoleApplication1.DomainModel
{
    using System;
    /// <summary>
    /// Address factory.
    /// </summary>
    /// <returns></returns>
    public delegate Address Factory();

    /// <summary>
    /// Employee.<see cref="DomainModel.Employee"/>
    /// </summary>
    [Serializable]
    public class Employee
    {
        public Employee() { }
        /// <summary>
        /// Mark employee instance.
        /// </summary>
        /// <param name="eID"></param>
        /// <param name="name"></param>
        /// <param name="sex"></param>
        /// <param name="addressFactory">address factory.</param>
        public Employee(string eID, string name, SexType sex, Factory addressFactory)
        {
            this.EId = eID;
            this.Name = name;
            this.Sex = sex;
            this.Address = addressFactory();
        }
        /// <summary>
        /// Primary id.
        /// </summary>
        public string EId { get; set; }

        /// <summary>
        /// Name.
        /// </summary>
        public string Name { get; set; }

        /// <summary>
        /// Sex.<see cref="DomainModel.SexType"/>
        /// </summary>
        public SexType Sex { get; set; }

        /// <summary>
        /// Address.
        /// </summary>
        public Address Address { get; set; }
    }
}
