﻿/*==============================================================================
 * Author:深度训练
 * Create time: 2013-08-04
 * Blog Address:http://www.cnblogs.com/wangiqngpei557/
 * Author Description:特定领域软件工程实践；
 *==============================================================================*/

namespace ConsoleApplication1.DomainModel.Specification
{
    using System;
    using System.Linq.Expressions;

    /// <summary>
    /// Employee add specification.
    /// </summary>
    [Serializable]
    public class EmployeeSpecificationAdd : System.Runtime.Serialization.IDeserializationCallback
    {
        /// <summary>
        /// specification.
        /// </summary>
        [NonSerialized]
        private Func<Employee, bool> _specification;
        /// <summary>
        /// Gets specification.
        /// </summary>
        public Func<Employee, bool> Specificaion { get { return _specification; } }

        /// <summary>
        /// employee.
        /// </summary>
        private Employee Employee { get; set; }

        /// <summary>
        /// Mark employee specificatoin.
        /// </summary>
        /// <param name="employee"></param>
        public EmployeeSpecificationAdd(Employee employee)
        {
            this.Employee = employee;
            InitSpecification();
        }
        /// <summary>
        /// Is Check.
        /// </summary>
        /// <returns></returns>
        public bool IsCheck()
        {
            return _specification(Employee);
        }

        public void OnDeserialization(object sender)
        {
            InitSpecification();
        }
        private void InitSpecification()
        {
            this._specification = (emp) =>
            {
                return !string.IsNullOrWhiteSpace(emp.EId) && !string.IsNullOrWhiteSpace(emp.Name);
            };
        }
    }
}
