﻿/*==============================================================================
 * Author:深度训练
 * Create time: 2013-08-04
 * Blog Address:http://www.cnblogs.com/wangiqngpei557/
 * Author Description:特定领域软件工程实践；
 *==============================================================================*/

namespace ORM.Meta
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using System.Threading.Tasks;

    /// <summary>
    /// Data source context.
    /// </summary>
    public abstract class DataBaseContext : List<MetaTable>, IDisposable
    {
        /// <summary>
        /// Data base name.
        /// </summary>
        protected string DataBaseName { get; set; }

        /// <summary>
        /// Connection string.
        /// </summary>
        protected string ConnectionString { get; set; }

        /// <summary>
        /// Provider child class add table.
        /// </summary>
        /// <param name="table"></param>
        protected virtual void AddTable(MetaTable table)
        {
            this.Add(table);
        }

        /// <summary>
        /// Init context.
        /// </summary>
        protected virtual void InitContext() { }
        public void Dispose() { }
    }
}
